
//cm3_ahb2_slave_demo
module cm3_ahb2_slave_demo
(
    sys_clk,
    send_en_button,
    rcv_en_button
);

input sys_clk;
input send_en_button;
input rcv_en_button;

wire send_en_out, rcv_en_out; 

//deUstb instantiation
deUstb uut_deUstb
(
    .out(send_en_out),
    .in(send_en_button),
    .clk(sys_clk),
    .rstn(1'b1)
);

//deUstb instantiation
deUstb uut_deUstb1
(
    .out(rcv_en_out),
    .in(rcv_en_button),
    .clk(sys_clk),
    .rstn(1'b1)
);

reg send_en_d1, rcv_en_d1;

wire         send_en;
wire         rcv_en;
wire  [31:0] t_hrdata;
wire         t_hready;
wire   [1:0] t_hresp;
wire   [1:0] t_htrans;
wire         t_hwrite;
wire         t_hsel;
wire  [31:0] t_hwdata;
wire  [31:0] t_haddr;
wire   [2:0] t_hsize;
wire         t_hready_in;

always@(posedge sys_clk) begin
    send_en_d1 <= send_en_out;
    rcv_en_d1 <= rcv_en_out;
end

assign send_en = send_en_out&&!send_en_d1;
assign rcv_en = rcv_en_out&&!rcv_en_d1;

//Gowin_EMPU_Top instantiation
Gowin_EMPU_Top u_Gowin_EMPU_Top
(
  .sys_clk(sys_clk),
  .reset_n(1'b1),
  //ahb2 slave
  .slave_hsel(t_hsel),
  .slave_haddr(t_haddr),
  .slave_htrans(t_htrans),
  .slave_hwrite(t_hwrite),
  .slave_hsize(t_hsize),
  .slave_hburst(),
  .slave_hprot(),
  .slave_hmemattr(),
  .slave_hexreq(),
  .slave_hmaster(),
  .slave_hwdata(t_hwdata),
  .slave_hmastlock(),
  .slave_hauser(),
  .slave_hwuser(),
  .slave_hrdata(t_hrdata),
  .slave_hready(t_hready),
  .slave_hresp(t_hresp),
  .slave_hexresp(),
  .slave_hruser()
);

//ahb_master instantiation
ahb_master u_ahb_master
(
    .hclk(sys_clk),
    .rstn(1'b1),
    .t_htrans(t_htrans),
    .t_hwrite(t_hwrite),
    .t_hsel(t_hsel),
    .t_hwdata(t_hwdata),
    .t_haddr(t_haddr),
    .t_hsize(t_hsize),
    .t_hready_in(t_hready_in),
    .t_hrdata(t_hrdata),
    .t_hready(t_hready),
    .t_hresp(t_hresp),    
    .send_en(send_en),
    .rcv_en(rcv_en),
    .rd_config_en(1'b0)
);

endmodule