
//test
module test_mode
(
    input               clk,
    input               reset,
    input               test_write,
    input               test_read,
    output reg          write_enable,
    output reg          read_enable,
    output reg [31:0]   user_addr,
    output reg [31:0]   user_wdata,
    input      [31:0]   user_rdata
);

reg [31:0] mem [15:0];

reg [4:0] write_count;
reg [4:0] read_count;

reg write_flag;
reg read_flag;

always@(posedge clk or negedge reset)
begin
    if(!reset)
    begin
        write_enable <= 1'b0;
        user_wdata <= 32'b0;
        write_count <= 4'b0;
    end
    else if(test_write)
    begin
        write_enable <= 1'b1;
        user_wdata <= write_count;
        write_count <= write_count + 1'b1;
    end
    else if(write_enable)
    begin
        write_enable <= 1'b0;
        user_wdata <= 32'b0;
        write_count <= write_count;
    end
end

always@(posedge clk or negedge reset)
begin
    if(!reset)
    begin
        read_enable <= 1'b0;
        read_count <= 4'b0;
    end
    else if(test_read)
    begin
        read_enable <= 1'b1;
        read_count <= read_count;
    end
    else if(read_enable)
    begin
        read_enable <= 1'b0;
        mem[read_count] <= user_rdata;
        read_count <= read_count + 1'b1;
    end
end

endmodule