
//cm3_userint_demo
module cm3_userint_demo
(
  sys_clk,
  reset_n,
  led,
  user_int,
  uart0_rxd,
  uart0_txd
);

input sys_clk;
input reset_n;

//LED
inout led;

//User interrupt input
input user_int;

//UART0
input uart0_rxd;
output uart0_txd;


wire mclk;      //mcu clock

//Gowin_PLLVR instantiation
Gowin_PLLVR u_Gowin_PLLVR
(
  .clkout(mclk),    // 100MHz -- for test
  .clkin(sys_clk)
);


wire user_int_i;

//key_debounce instantiation
key_debounce u_key_debounce
(
  .clk(mclk),
  .rst_n(reset_n),
  .key_n(user_int),
  .key_o(user_int_i)
);


//Gowin_EMPU_Top instantiation
Gowin_EMPU_Top u_Gowin_EMPU_Top
(
  .sys_clk(mclk),
  .reset_n(reset_n),
  .gpio(led),
  .uart0_rxd(uart0_rxd),
  .uart0_txd(uart0_txd),
  .user_int_0(user_int_i)
);

endmodule