
`timescale 1ps/1ps

`ifdef SIM
  `define DEBCNT 20'h00001
`else
  `define DEBCNT 20'h0ffff
`endif

//key_debounce
module key_debounce
(
    clk, 
    rst_n, 
    key_n, 
    key_o
);

input clk;
input rst_n;
input key_n;
output key_o;

reg key_rst;

always @(posedge clk or negedge rst_n)
begin
    if(~rst_n)
        key_rst <= 1'b1;
    else
        key_rst <= key_n; 
end

reg key_rst_r;

always @(posedge clk or negedge rst_n)
begin
    if(~rst_n)
        key_rst_r <= 1'b1;
    else
        key_rst_r <= key_rst; 
end

wire key_an = key_rst_r ^ key_rst;

reg [19:0] cnt; 

always @(posedge clk or negedge rst_n)
begin
    if(~rst_n)
        cnt <= 20'd0;
    else if(key_an)
        cnt <= 20'd0;
    else
        cnt <= cnt + 20'd1;
end

reg key_o;
reg flag;

always @(posedge clk or negedge rst_n)
begin
    if(~rst_n)
    begin
        key_o <= 1'b0;
        flag <= 1'b0;
    end
    else if((cnt == `DEBCNT) & (key_n == 1'b0) & (flag == 1'b0)) // 2^20*1/(50MHZ)=20ms
    begin
        key_o <= 1'b1; 
        flag <= 1'b1;
    end
    else if((key_o == 1'b1) & (flag == 1'b1))
    begin
        key_o <= 1'b0;
    end
    else if(key_n == 1'b1)
    begin
        flag <= 1'b0;
    end
end

endmodule