/*
 ******************************************************************************************
 * @file      main.c
 * @author    GowinSemiconductor
 * @device    Gowin_EMPU(GW1NS-4C)
 * @brief     Main function.
 ******************************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include "printf_demo.h"
#include <stddef.h>


/* Definitions ---------------------------------------------------------------*/

typedef __UINT32_TYPE__ __uint32_t;
typedef __uint32_t uint32_t ;

void gcov_init(void)
{
	void (**p)(void);
	extern uint32_t __init_array_start, __init_array_end; /* linker defined symbols, array of function pointers */
	uint32_t beg = (uint32_t)&__init_array_start;
	uint32_t end = (uint32_t)&__init_array_end;

	while(beg<end)
	{
		p = (void(**)(void))beg; /* get function pointer */
		(*p)(); /* call constructor */
		beg += sizeof(p); /* next pointer */
	}
}

//Application entry function
int main(void)
{
	gcov_init();

	printf_demo();

	while(1);
}
