/*
 ******************************************************************************************
 * @file      main.c
 * @author    GowinSemiconductor
 * @device    Gowin_EMPU(GW1NS-4C)
 * @brief     Main program body.
 ******************************************************************************************
 */

/* Includes ------------------------------------------------------------------*/
#include "uart.h"
#include <stdio.h>


/* Definitions ---------------------------------------------------------------*/

//#define FIFO_WRITE_TEST
#define FIFO_READ_TEST

void delay(__IO uint32_t nCount)
{
	for(; nCount != 0; nCount--);
}

int main(void)
{
	SystemInit();  			 //Initializes system clock
	uart_init(UART0,     //Initializes UART0
	          38400,     //Baudrate
	          1,         //Tx
	          1,         //Rx
	          0,         //Tx interrupt
	          0,         //Rx interrupt
	          0,         //Tx overflow interrupt
	          0);        //Rx overflow interrupt

#ifdef FIFO_WRITE_TEST
	//Write test
	//MCU channel writes and FPGA channel reads
		uint32_t write_data[4] =
	{
		0x01234567,
		0x89abcdef,
		0xfedcba98,
		0x76543210
	};															//Write data test
	
	for(int i = 0; i < 4; i++)
	{
		*(uint32_t *)(APB2MASTER1_BASE + i*4) = write_data[i];
		printf("0x%08x\r\n", write_data[i]);
	}
#endif
	
#ifdef FIFO_READ_TEST
	//Read test
	//FPGA channel writes and MCU channel read
	delay(43330000);
	
	uint32_t read_data[4] = {0};		//Read data test
	
	for(int i = 0; i < 4; i++)
	{
	  read_data[i] = *(uint32_t *)(APB2MASTER1_BASE + i*4);
		printf("0x%08x\r\n", read_data[i]);
	}
#endif
	
  while(1);
}
